///////////////////////////////////////////////////////////////////////
// CharaObject.h	LN^[IuWFNg

#pragma once

namespace YJ_Lib
{
	struct CHARA_OBJECT
	{
		enum SCENE_TYPE {
			SCENE_TYPE_NORMAL,		// W`p
			SCENE_TYPE_YJV			// A^C_O[r[p
		} scene_type;

		enum DRAW_TYPE {
			DRAW_TYPE_NONE,			// wȂ
			DRAW_TYPE_EFFECT		// GtFNg
		} draw_type;


		bool	flag;				// ɃtO

		int		id;					// IuWFNgID
		int		model_id;			// 3DfID( MODEL3 )

		bool	draw_flag;			// `tO
		bool	clip_flag;			// `NbvtO
		bool	clipped_flag;		// `Nbv( true:Nbvꂽ̂ŕ`悵Ȃ )

		XYZ		pos;				// W
		XYZ		angle;				// px(}gNX)
		XYZW	qtn;				// px(NH[^jI)
		XYZ		size;				// TCY

		COLOR	color;				// F( `惂[hVB_TYPE_OFF̎f )


		// }bvp
		XYZ		pos_base;
		//XYZ		pos_offset;


		// ݃GtFNgp
		int		eff_frame;			// [Vt[
		float	eff_frame_add;		// [Vt[Zp

		// Map3RW֘A
		XYZ		move_vec;			// LibRWd͂̈ړ
		bool	coll_hit_flag;		// LibRWŃqbgH
		int		coll_hit_ground;	// n
		int		coll_hit_wall;		// 

		//bool	friction;			// C

		bool	slip_flag;			// tO
		//float	slip;				// l

		bool	coll_flag;			// LibŃRW肷邵ȂtO


		// p
		int		parent_chara_id;
		int		parent_bone_id;
		//MATRIX	equip_mtx;

		// tbVp
		//BOOL  FlashFlag;
		//BOOL  FlashTexFlag;
		//COLOR FlashColor;
		//int   FlashTime;


		// 3Df [V֘A
		
		// {[
		struct BONE {
				
			XYZ  PosEditPoint;	// StudioŕҏWp
			XYZ  PosPoint;
			XYZW QtnPoint;
			XYZ  SizePoint;

			int   KeyNo;	// ߂L[t[
			float KeyF;		// L[t[̊Ԃ̏ꏊ



			// {[ƂɃ[Vݒ
			bool	motion_flag;
			int		motion_no;		// Đ̃[VNo
			int		frame;			// ݂̃t[No
			float	frame_add;		// t[Zp
		};
			
		BONE B[ BoneMax ];

		// {[vZ̒_f[^
		vector<XYZ> WV;
		vector<XYZ> WN;

		
		int		frame;
		float	frame_add;				// t[Zp

		int		ML_Now;					// ݂̃[VXgNo
		int		ML_Now_ChangeWait;		// [V؂ւ҂
		char	ML_Now_ChangeWaitName[ BUF_MAX ];

		bool	motion_one_repeat_flag;	// Motion()sA[VŌ܂ōĐꂽtrue

		int  VB_TypeNo;
		BOOL VB_SetFlag;


		//
		CHARA_OBJECT();
		~CHARA_OBJECT();

		void Init();

		virtual void Draw(){}
		virtual void Update(){}


		bool PosSet( XYZ );		// W
		bool PosSet( float x, float y, float z );

		bool AngleSet( XYZ );	// px( }gNX )
		bool AngleSet( float x, float y, float z );

		bool AngleAdd( XYZ );	// ݂̊px{( }gNX )
		bool AngleAdd( float x, float y, float z );

		bool QtnSet( XYZW );	// px( NH[^jI )

		bool SizeSet( XYZ );	// TCY
		bool SizeSet( float x, float y, float z );


		bool DrawFlagSet( bool );	// \EȂ
		bool ModelIdSet( int );		// ModelIDݒ

		bool NormalSet();			// @vZ

		bool Motion( int _motion );						// [Vݒ
		bool Motion( int _motion, float _blend_speed );	// [Vݒ [Vuhx Tvl 0.3f ` 3.0f
		bool Motion( char* _name );						// [VŃ[Vݒ
		bool Motion( char* _name, float _blend_speed );	// [VŃ[Vݒ [Vuhx Tvl 0.3f ` 3.0f

		void BoneMotion( int _bone, int _motion );							// {[ƂɃ[Vݒ()
		void BoneMotion( int _bone, int _motion, float _blend_speed );		// {[ƂɃ[Vݒ() [Vuhx Tvl 0.3f ` 3.0f
		
		void BoneMotion( char* _bone, char* _motion );						// {[ƂɃ[Vݒ()
		void BoneMotion( char* _bone, char* _motion, float _blend_speed );	// {[ƂɃ[Vݒ() [Vuhx Tvl 0.3f ` 3.0f
		
		void BoneMotionChild( int _bone, int _motion, float _blend_speed );	// {[ƂɃ[Vݒ(qp)


		void BoneMotionFrameNo( int _bone, int _frame_no );			// {[ƂFrameNoݒ()
		void BoneMotionFrameNo( char* _bone, int _frame_no );		// {[ƂFrameNoݒ()
		void BoneMotionFrameNoChild( int _bone, int _frame_no );	// {[ƂFrameNoݒ(qp)


		//////////////////////////////////////////////////////////////////////////
		// ჌x֐


		bool VB_Set();				// VertexBuffer쐬
		bool VB_Type( VB_TYPE );	// int ua^Cv

		bool MotionKeyFrameCheck();
		bool MotionSP( int, int, float );

		//bool BoneBaseMatrix();
		bool BoneMotionMatrix();
		bool BoneVertex();			// {[_vZ
	};

	void CharaObjectInit();					// 
	int	 CharaObjectCreate();				// 쐬
	void CharaObjectDelete(int);			// IuWFNg
	void CharaObjectDeleteALL();			// SIuWFNg
	CHARA_OBJECT* CharaObjectGet(int);		// |C^擾
	int	 CharaObjectUseNum();				// IuWFNggp̐擾
	int	 CharaObjectNum();					// IuWFNg擾
	bool CharaObjectCopy( int s, int e );	// IuWFNgf[^Rs[


	
	//////////////////////////////////////////////////////////////////////////
	// ჌x֐

	// Set
	XYZ BoneMatSetVtx3( int p, int b );

	// Motion
	XYZ BoneMatVtx3( int p, int b );

	// Q[pLWpx
	void BoneMatYJ( int p );

	// eIuWFNgw肳Ăꍇ
	void BoneMatParent( int p );
}
