///////////////////////////////////////////////////////////////////////
// Define.h

//#pragma once


#ifndef SAFE_DELETE
	#define SAFE_DELETE(p){ if(p){ delete (p); (p)=NULL; } }
#endif

#ifndef SAFE_DELETE_ARRAY
	#define SAFE_DELETE_ARRAY(p){ if(p){ delete[] (p); (p)=NULL; } }
#endif

#ifndef SAFE_RELEASE
	#define SAFE_RELEASE(p){ if(p){ (p)->Release(); (p)=NULL; } }
#endif



#define OBJECT_MAX	 256

// IuWFNg2D
#define YJA_Max		   8
#define YJA_ObjMax	  (32+1)	//(16+1)	// 0 e(p)
#define YJA_ImgMax	   32	//8	// 0 C[WȂ  1`
#define YJA_KeyMax	   8

#define YJB_Max		  32	// Qcf


// GtFNg
//#define EffectMax			32	// GtFNgő哯\
#define EffectObjectMax		 3	// f[^ p[cő吔
#define EffectParameterMax	 8	// ep[^[

// GtFNg p[eBN
#define EffectParticleMax			32	// GtFNgő哯\
#define EffectParticleObjectMax		 3	// f[^ p[cő吔
#define EffectParticleParameterMax	 8	// ep[^[


// f2D
#define MotionListMax2	100	// [VXg


// IuWFNg3D
#define ObjMax3			 16	// 3Df IuWFNg
#define ObjPartsMax3	 32


// f3D
#define ModelMax3	   1024 //256	// 3Df XL

#define BoneMax			128	//32	// {[
#define GroupMax	    256	//128	// O[v

#define ImageMax	   1024	// 2DC[W

#define KeyMax			 16	// P[VŎgL[
#define MovieFrameMax 18000	// ( T )
#define TexMax	   GroupMax	// eNX` ( GroupMaxȏKv )
//#define TextMax			128	// eLXg
#define VtxMax			  4	// _
#define WaveMax			100	// ʉ

#define BUF_MAX			256	// Lzp

#define FREE(p){ if(p){ free(p); p = NULL; } }



#define ON	1
#define OFF	0

#define YES	1
#define NO	0






//////////////////////////////////////////////////////////////////////////////////////////////
// YJ Studio p

// Studiop
#define TreeMax	256		// BoneMax or ObjPartsMax3 ̑傫
#define WinMax	  8		// Studio EBhEp


// Qc}bvҏW
#define Map2_MaxX		64
#define Map2_MaxY		64
#define Map2_MaxImage	16


// RWҏW
#define ColiBoxMax		100		// (BOX)
#define ColiCircleMax	100		// (~)
#define ColiMapSU		 10		// wi\pt@C


// vOҏW
//#define HensuMax	 100	// ϐ̍ő吔
#define VarMax		 100	// ϐ̍ő吔
#define ProgMax		1000	// vO̍ő吔
#define ReturnMax	 100	// ֐Ap
#define SubMax		   5	// Subz( Qڂ̔z )
#define YJS_DrawMax 1024	// vOҏWp ő`搔
#define YJS_SubMax	 100	// Tu֐
#define LabelMax	 100











// L[{[h
#define KEY_A 65
#define KEY_B 66
#define KEY_C 67
#define KEY_D 68
#define KEY_E 69
#define KEY_F 70
#define KEY_G 71
#define KEY_H 72
#define KEY_I 73
#define KEY_J 74
#define KEY_K 75
#define KEY_L 76
#define KEY_M 77
#define KEY_N 78
#define KEY_O 79
#define KEY_P 80
#define KEY_Q 81
#define KEY_R 82
#define KEY_S 83
#define KEY_T 84
#define KEY_U 85
#define KEY_V 86
#define KEY_W 87
#define KEY_X 88
#define KEY_Y 89
#define KEY_Z 90

#define KEY_0 48 // L[{[ĥO
#define KEY_1 49
#define KEY_2 50
#define KEY_3 51
#define KEY_4 52
#define KEY_5 53
#define KEY_6 54
#define KEY_7 55
#define KEY_8 56
#define KEY_9 57

#define KEY_UP		38	//  L[
#define KEY_RIGHT	39	// E
#define KEY_DOWN	40	// 
#define KEY_LEFT	37	// 

#define KEY_NUM_0 96 // eL[̂O
#define KEY_NUM_1 97
#define KEY_NUM_2 98
#define KEY_NUM_3 99
#define KEY_NUM_4 100
#define KEY_NUM_5 101
#define KEY_NUM_6 102
#define KEY_NUM_7 103
#define KEY_NUM_8 104
#define KEY_NUM_9 105

#define KEY_PIRIODO 110	// sIh
#define KEY_PURASU	107 // {
#define KEY_MAINASU 109 // |
#define KEY_KAKERU	106 //  
#define KEY_WARU	111 // ^ 
#define KEY_NUMLOCK 144 // NumLock

#define KEY_ESC		27	// ESCL[
#define KEY_KANJI	229	// (p/Sp)
#define KEY_TAB		9	// TAB
#define KEY_CAPS	240	// CapsLock
#define KEY_SHIFT	16	// VtgL[
#define KEY_CTRL	17	// Rg[L[
#define KEY_SPACE	32	// Xy[XL[
#define KEY_ENTER	13	// G^[L[
#define KEY_BS		8	// Back Space

#define KEY_PAGEUP		33
#define KEY_PAGEDOWN	34
#define KEY_INSERT		45
#define KEY_HOME		36
#define KEY_DELETE		46
#define KEY_END			35

#define KEY_F1  112
#define KEY_F2  113
#define KEY_F3  114
#define KEY_F4  115
#define KEY_F5  116
#define KEY_F6  117
#define KEY_F7  118
#define KEY_F8  119
#define KEY_F9  120
#define KEY_F10 121 // ( j[o[ANeBu )
#define KEY_F11 122
#define KEY_F12 123
