///////////////////////////////////////////////////////////////////////
// Effect.h

#pragma once

namespace YJ_Lib
{
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// GtFNg p[eBN ҏW -> GtFNgҏWTypep[eBNɋz

	// f[^u
	struct EffectParticleData
	{
		struct KEY {

			//////////////////////////////////////////
			// Lϐ

			int Frame;		// eL[̃t[No

			// [VXg(f)
			// ANeBuȃJNo(V[)
			// ʉEbZ[W
			int No;


			//////////////////////////////////////////
			// Type

			// f
			XYZ Pos;	// J̎_pƋL
			XYZ Ang;
			XYZ Size;

			COLOR Color;	// fEV[

			XYZ Pos2;	// J _p


	//		int Motion;	// eL[̃[VXgNo  f

			// V[p
	//		int ActCamNo;	// ANeBuȃJNo
		};

		// GtFNg
		struct PARTS {

			//char FileName[ BUF_MAX ];	// YJEt@C
			char Name[ BUF_MAX ];	// \p

			int KeySU;
			KEY Key[ KeyMax ];

			int Type;		// GtFNg̎
			int SubType;	// vOpTu^Cv


			// [Ṽ^Cv  0 JNJN  1 X[Y
			int AniTypePos;
			int AniTypeAng;
			int AniTypeSize;


			int   KeyS;	// ߂L[t[
			int   KeyE;
			float KeyC;	// L[t[̊Ԃ̏ꏊ

			int NowMotion;
			int zzz[ MovieFrameMax ];

			XYZ PosPoint;
			XYZ Pos2Point;
			XYZ AngPoint;
			XYZ SizePoint;

			//char Folder[ BUF_MAX ];		// tH_
			//char File[ BUF_MAX ];	// YJP t@C( fp )
			//char MoFile[ BUF_MAX ];  // YJM [Vt@C( fp )

		} P[ EffectParticleObjectMax ];

		int Ver;

		char File[ BUF_MAX ];	// YJEt@C
					
		int PartsSU;
		int LastFrame;

		// ʉ
//		BUF WaveFolder[ KeyMax ];
//		BUF WaveFile[ KeyMax ];
//		int WaveSU;

	};


	// GtFNg p[eBN \p
	struct EffectParticle
	{
		BOOL Flag;

		int no;  // f[^No

		int f;
		int LastFrame;

		int x, y;

	};


	//
	//void YJEP_Load( char* );
	//void YJEP_Save( char* );

	void YJEP_Init(int);
	//void YJEP_LoopFlag( BOOL );
	//void YJEP_Delete();

	void YJEP_Animation();
	void YJEP_AM();
	void YJEP_ZZZ();
	void YJEP_SP( int, int, int, float );
	void YJEP_KeyFrameCheck();

	// GtFNg p[eBNp
	//////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////
	// GtFNg

	struct EFFECT
	{
		// f[^
		struct Data
		{
			enum Type {
				TypeImage,		// 2DC[W
				TypeParticle,	// p[eBN2D
				TypeYJA,		// YJA`(2D)
				TypeBillborad,	// r{[h(3D4p`)
				TypeModel3,		// 3Df(YJP)
				TypeParticle3	// p[eBN3D
			};


			// C[WXg
			struct ImageList {

				FileData file;

				// ۑȂf[^
				int image_id;
			};
			vector<ImageList> image_list;


			// 3DfXg
			struct ModelList {

				FileData file;

				// ۑȂf[^
				int model_id;
			};
			vector<ModelList> model_list;


			// p[eBNp
			struct Particle {
				
				short	interval;		// 쐬Ԋu
				short	create_num;		// 쐬

				struct Base {
					XYZW init_speed;	// l
					XYZW init_random;	// _
					XYZW add_speed;		// l
					XYZW add_random;	// _
					XYZW offset;		// ItZbgl
					XYZW offset_random;	// ItZbg_
				};

				Base pos;
				Base angle;
				Base scale;
				Base color;
			};

			// L[P̏
			struct Key {

				//////////////////////////////////////////
				// Common

				int Frame;	// eL[̃t[No


				// [VXg(f)
				// ANeBuȃJNo(V[)
				// ʉEbZ[W
				int No;

				bool draw_flag;  // \tO

				DRAW_MODE draw_mode;	// `惂[h

				XYZ Pos;	// J̎_pƋL
				XYZ Angle;	// 2DZgp
				XYZ Scale;
				COLOR Color;

				

				//////////////////////////////////////////
				// 2Dp
				
				int image_index;	// image_listQ


				//////////////////////////////////////////
				// 3Dp

				int	model_index;	// model_listQ

				bool billboard;		// r{[h

				XYZ Pos2;			// J _p(gp)


				//////////////////////////////////////////
				// p[eBNp

				Particle particle;



				//////////////////////////////////////////
				//

				Key(){
					memset( this, 0, sizeof(Key) );
				}
			};

			// p[c
			struct Parts {

				char name[ BUF_MAX ];	// \p

				int type;	// GtFNg̎

				// tH_Et@C
				FileData file;

				int key_num;
				Key key[ KeyMax ];

				// [Ṽ^Cv  0 JNJN  1 X[Y
				int AniTypePos;
				int AniTypeAng;
				int AniTypeSize;


				//////////////////////////////////////////////
				// ۑȂf[^

				vector<int> effect_frame;	// FrameOvZp


				// IuWFNg(e)̃ItZbg
				XYZ	pos2;
				XYZ pos3;
				XYZ	angle;

				// YJA,YJP`p
				int file_id;


				/////////////////////////////////////////////////
				//

				Parts();

				void Init();
			};
			vector<Parts> P;			// p[c

			int		PartsCreate();		// 쐬
			Parts*	PartsGet(int);		// |C^擾
			int		PartsNum();			// p[c擾

			void	PartsDelete(int);	// 


			int Ver;

			FileData file;	// t@C

			int	frame_last;	// Ō̃t[

			// C[W
			// L[ɂC[W؂ւsvȏꍇ
			// p[cPɃC[WP
			// ͎gpȂŁAKey[0].image_id g悤ɂ
			int image_id;
	

			// ʉ
			//BUF WaveFolder[ KeyMax ];
			//BUF WaveFile[ KeyMax ];
			//int WaveSU;

			bool loop_flag;		// [vĐtO



			///////////////////////////////////////////////////////////////
			// ۑȂf[^

			bool flag;





			///////////////////////////////////////////////////////////////
			//

			Data();
			~Data();

			void Init();

			bool YJE_Save( char *folder, char* );

			void FrameSet();	// FrameOvZ
		};

		int		DataCreate();	// 쐬
		Data*	DataGet(int);	// |C^擾
		int		DataNum();		// GtFNg擾

		void	DataDelete( int obj );	// 
		void	DataDeleteALL();		// S

		int		YJE_Load( char *folder, char *filename );
		void	YJE_LoadCommon( int _data_id );	// EffectLoad̋ʏ


		Data::Key KeyBuf;	// L[Rs[p



		///////////////////////////////////////////////////
		// GtFNg \p

		struct Object
		{
			enum Type {
				TypeProg,	// vOx[X̃GtFNg
				TypeData	// f[^t@CgpGtFNg
			};

			enum PosType {
				PosType2,
				PosType3,
				PosTypeBillboard,
			};


			bool	flag;
			int		type;		// 0:Prog 1:Data
			int		data_id;	// \GtFNgf[^ID

			int		frame_now;	// ݂̃t[
			float	frame_add;	// t[Zp


			PosType pos_type;
			XYZ pos;

			XYZ	angle;
			XYZ size;

			//bool delete_flag;
			


			// p[c
			struct Parts {

				// KeyԌvZ̃f[^u
				XYZ		PosPoint;
				XYZ		Pos2Point;
				XYZ		AnglePoint;
				XYZ		ScalePoint;
				COLOR	ColorPoint;

				int   KeyS;	// ߂L[t[
				int   KeyE;
				float KeyC;	// L[t[̊Ԃ̏ꏊ

				// p[eBNp
				int	interval_now;

				// DrawGroupListo^p
				int obj_id;		// CharaObjectCreate();
			};
			vector<Parts> parts;


			//
			Object();
			~Object();

			void KeyFrameCheck();
		};

		int		YJE_Status;  // 0 ~  1 Đ  2 ĐI


		int		ObjectCreate( int _data_id, Object::PosType _pos_type );	// 쐬
		Object* ObjectGet( int obj );		// |C^擾
		int		ObjectNum();				// GtFNg擾

		void	ObjectDelete( int obj );	// 
		void	ObjectDeleteALL();			// S

		void	Update( float progress_time );

		void	YJE_SP( int, int, int, int, float );


		// p[eBN֘A
		void	ParticleUpdate( float progress_time );
		void	ParticleDraw();

		void	ParticleDelete();
		void	ParticleObjectDelete( int obj );
	};
}
