///////////////////////////////////////////////////////////////////////
// Map3.h

#pragma once

namespace YJ_Lib
{
	struct MAP3
	{
		enum COLI_TYPE {
			COLI_TYPE_NONE,
			COLI_TYPE_BOX,
			COLI_TYPE_CIRCLE,
		};


		int Ver;

		// őړ\͈
		float SX, SY, SZ,  EX, EY, EZ;


		// (BOX)
		struct BOX
		{
			BOOL	Flag;
			XYZ		Pos;	//float	x, y, z;
			float	Ang;
			float	Size;

			void	Init();

		} Box[ ColiBoxMax ];

		int BoxSU;



		// (~)
		struct CIRCLE
		{
			BOOL	Flag;
			XYZ		Pos;	//float	x, y, z;
			float	Size;

			void	Init();

		} Circle[ ColiCircleMax ];

		int CircleSU;



		// 3DRW
		char ColiFile[ BUF_MAX ];


		// wi\pt@Cꗗ
		BOOL MapFlag[ ColiMapSU ];
		char MapFile[ ColiMapSU ][ BUF_MAX ];



		/////////////////////////////////////////////////////
		// 3Dfzuf[^

		// x[X
		struct BASE3
		{
			char		folder[ BUF_MAX ];
			char		filename[ BUF_MAX ];

			COLI_TYPE	coli_type;
			XYZ			coli_angle;
			XYZ			coli_size;


			// p[^
			struct Param
			{
				char	str[ BUF_MAX ];	// 
				//int		value;			// l

				void Init();
			};
			vector<Param> param;



			// ۑȂf[^
			int			model_id;


			// RXgN^
			BASE3(){
				Init();
			}

			void Init();		// 
		};

		vector<BASE3>	Base3;
		int				Base3_Num;


		// zu
		struct PLACE3
		{
			int		base_id;	// x[XID
			bool	draw_flag;	// \tO
			XYZ		pos;		// W
			XYZ		angle;		// px
			XYZ		size;		// TCY


			// p[^
			struct Param
			{
				char	data[ BUF_MAX ];	// 
				//int		value;			// l

				void Init();
			};
			vector<Param> param;



			// ۑȂf[^
			int		object_id;


			// RXgN^
			PLACE3(){
				Init();
			}

			void Init();		// 
		};

		vector<PLACE3>	Place3;
		int				Place3_Num;



		/////////////////////////////////////////////////////
		// GtFNgf[^

		struct EFFECT
		{
			bool	flag;		// LtO
			XYZ		pos;		// W
			XYZ		angle;		// px
			XYZ		size;		// TCY

			char	folder[ BUF_MAX ];
			char	filename[ BUF_MAX ];


			// ۑȂf[^
			int		data_id;
			int		object_id;


			void	Init();		// 
		};

		vector<EFFECT>	Effect;
		//int				EffectNum;



		/////////////////////////////////////////////////////
		// Cxgpf[^

		struct EVENT
		{
			bool	flag;		// LtO
			XYZ		pos;		// W
			XYZ		size;		// TCY

			char	name[ BUF_MAX ];	// Cxg


			// p[^
			struct Param
			{
				char	str[ BUF_MAX ];	// 
				//int		value;			// l

				void Init();
			};
			vector<Param> param;


			void	Init();		// 
		};

		vector<EVENT>	Event;
		int				EventNum;








		//////////////////////////////////////////////////////////////////////////////////////////
		// t@CɕۑȂAꎞIȃf[^

		int id;

		bool flag;						// ɃtO( false: true: )

		bool collision_flag;			// trueȂMap3`̓蔻ACuŏ
		bool collision_max_move_flag;	// trueȂőړ͈(X,Z)̓蔻ACuŏ

		char filename[ BUF_MAX ];		// Map3t@C


		// wif
		CHARA_OBJECT	*map_obj;
		int				map_obj_id;
		MODEL3			*map_model;
		int				map_model_id;

		// RWf
		MODEL3	*collision_model;
		int		collision_model_id;


		float LandTop;	// nʂ̍

		int HitFaceNo;

		XYZ	offset;



		// ֐
		MAP3();					// RXgN^
		~MAP3();				// fXgN^

		void Init();			// 
		void CollisionCheck();	// CuŃRWvZ
		void Save( char* );		// t@Cɕۑ
	};

	int		Map3_Create();		// 쐬
	MAP3*	Map3_Get(int);		// |C^擾
	int		Map3_Num();			// IuWFNg擾

	int		Map3_Load( char* );

	//void	Map3_Delete();
	void	Map3_Delete(int);	// }bv
	void	Map3_DeleteALL();	// S}bv

}

extern MAP3* pMap3;
