///////////////////////////////////////////////////////////////////////
// Movie.h

#pragma once

namespace YJ_Lib
{
	struct MOVIE
	{
		// MovieTypeBufZbgōXV邱
		enum TYPE {
			TypeImage,
			TypeYJA,
			TypeYJB,
			TypeYJO,
			TypeYJP,
			TypeCamera,
			TypeScene,
			TypeBgm,
			TypeWave,
			TypeMes,
			TypeYJE2,	// 2DGtFNg
			TypeYJE3,	// 3DGtFNg
			TypeMax
		};

		enum ST {
			StStop,
			StPlay,
			StEnd	// YJCuōĐIAQ[pf[^ă[hp -> [h StStop Zbg
		};


		struct KEY {

			///////////////////////////////////////////////////////////////////////
			// Lϐ

			int		Frame;		// eL[̃t[No

			bool	draw_flag;

			// [VXg(f)
			// ANeBuȃJNo(V[)
			// ʉEbZ[W
			int		No;


			///////////////////////////////////////////////////////////////////////
			// Type

			// f ( 2D3DL )
			XYZ		Pos;	// J̎_pƋL

			XYZ		Ang;	// 2DZgp
			XYZW	Qtn;	// 3Dp(gp)

			XYZ		Size;

			COLOR	Color;	// fEV[

			XYZ		Pos2;		// J _p


			//int Motion;	// eL[̃[VXgNo  f

			// V[p
			//int ActCamNo;	// ANeBuȃJNo
		};


		// [r[ OBJECT
		struct OBJECT {

			char	Name[ BUF_MAX ];	// \p

			int		KeySU;
			int		Type;	// fEJECg

			// [Ṽ^Cv  0 JNJN  1 X[Y
			int		AniTypePos;
			int		AniTypeAng;
			int		AniTypeSize;

			KEY		Key[ KeyMax ];

			
			
			char	Folder[ BUF_MAX ];	// tH_
			char	File[ BUF_MAX ];	// t@C( fGtFNgp )
			char	MoFile[ BUF_MAX ];	// YJM [Vt@C( fp )

			//int ShadowType;  // VhE
			SHADOW_TYPE	ShadowType;


			///////////////////////////////////////////////////////////////////////
			// ۑȂf[^

			int		id;			// MOVIE::OBJECT ID

			int		object_id;	// IuWFNgID( EffObj )
			int		data_id;	// f[^ID( EffData )

			int		yj_object_id;	// OBJECT
			int		yj_model_id;	// MODEL3

			int		KeyS;		// ߂L[t[
			int		KeyE;
			float	KeyC;		// L[t[̊Ԃ̏ꏊ

			int		NowMotion;
			int		zzz[ MovieFrameMax ];

			// 2D&3DL
			XYZ		PointPos;
			XYZ		PointPos2;

			XYZ		PointAng;	// 2DZgp
			XYZW	PointQtn;	// 3Dp(gp)

			XYZ		PointSize;
			COLOR	PointColor;
		};
	
		vector<OBJECT*> Object;


		// Objectp ֐
		int		ObjectCreate();				// IuWFNg쐬
		void	ObjectCopy( int s, int e );	// IuWFNgRs[
		void	ObjectDelete(int);			// IuWFNg폜
		OBJECT* ObjectGet(int);				// IuWFNg擾
		int		ObjectNum();				// IuWFNg擾





		KEY KeyBuf;		// [r[p


		//
		int		Ver;

		int		f;
		float	f_add;	// t[Zp
		int		f_last;

		// Map3
		bool	map3_flag;
		int		map3_id;
		char	map3_folder[ BUF_MAX ];
		char	map3_file[ BUF_MAX ];

		// BGM
		BOOL	BgmFlag;
		char	BgmFolder[ BUF_MAX ];
		char	BgmFile[ BUF_MAX ];
		int		bgm_volume;

		// ʉ
		BUF		WaveFolder[ KeyMax ];
		BUF		WaveFile[ KeyMax ];
		int		wave_volume[ KeyMax ];
		int		WaveNum;

		// bZ[W
		BUF		Mes[ KeyMax ];
		int		MesNum;

		// NextYJV
		BOOL	NextFlag;
		char	NextFile[ BUF_MAX ];	// YJV


		///////////////////////////////////////////////////////////////////////////
		// ۑȂf[^

		BOOL	Flag;

		int		Status;		// 0 ~  1 Đ  2 ĐI

		char	folder[ BUF_MAX ];	// tH_
		char	file[ BUF_MAX ];	// t@C

		BOOL	EditNextFlag;				// ĐAYJVǂݍށH ( ҏWp )
		char	EditNextFile[ BUF_MAX ];	// YJV MovieInit()ĂNextYJVc

		int		ActCamNo;

		vector<int> se_id;	// ʉID

		bool	HLSL_now;	// ݂HLSLۑčĐɖ߂p


		////////////////////////////////////////////////////
		// ֐

		MOVIE();	// RXgN^
		~MOVIE();	// fXgN^

		void Load( char* );
		void Save( char* );

		void Init();
		void Delete();
		void Update();

		void KeyFrameCheck();
		void SP( int, int, float );

		//bool WaveLoad( int, char* );
		//bool WavePlay( int );

		void ZZZ();		// Movie.f_ł̃[VFrameNovZ

	};
}
