///////////////////////////////////////////////////////////////////////
// Obj3.h

#pragma once

namespace YJ_Lib
{
	struct OBJ3
	{
		struct MOTION_LIST {

			BOOL Flag;
			BOOL Repeat;
			char Name[ BUF_MAX ];
			int  Frame;

			int KeySU;
			int F[ KeyMax ];
		};


		struct KEY {
			XYZ Pos;
			XYZ Angle;
			XYZ Size;
		};


		struct ML_PARTS {

			KEY *K;

			// ۑȂf[^
			int K_Mem;
		};


		struct PARTS {

			ML_PARTS *M;


			char File[ BUF_MAX ];	// 0 YJO  1 eYJPp

			int DrawNo;

			int Parent;
			int Child;
			int Sibling;
			int Dan;


			////////////////////////////////////////////////////////////
			// ۑȂf[^

			//XYZ PosEditPoint;	// StudioŕҏWp
            XYZ PosPoint;
			XYZ AnglePoint;
			XYZ SizePoint;

			// YJ Studio Editp
			BOOL OpenFlag;
			BOOL OpenDrawFlag;	// ۂɕ\H
		};


		int Ver;
		int SU;


		// p[c
		XYZ		Base[ ObjPartsMax3 ];	// x[X
		PARTS	P[ ObjPartsMax3 ];		// [V


		// [VXg
		MOTION_LIST ML[100];
		int ML_SU;
		int ML_Mem;


		// ʉ
		char WaveFile[ WaveMax ][ 32 ];
		int  WaveSU;

		int  WaveNo[ KeyMax ];


		//
		int LastFrame;
		int	LoopS, LoopE;

		// [Ṽ^Cv  0 JNJN  1 X[Y
		int AniTypeMove;
		int AniTypeAng;
		int AniTypeSize;


		///////////////////////////////////////////////////////////////////////////////////
		// t@CɕۑȂf[^

		int		ID;		// OBJ3ID
		int		obj_id;	// YJ.OBJECTID;

		int		f;
		float	f_add;	// t[Zp

		int		ML_Now;	// ݂̃[VXgNo

		int		KeyNo;	// ߂L[t[
		float	KeyF;	// L[t[̊Ԃ̏ꏊ

		// fTCY( őEŏ )
		XYZ	Min;
		XYZ	Max;

		// \ʒu
		XYZ	Pos;
		XYZ	Ang;
		XYZ	Size;


		/////////////////////////////////////////////////////////////////////////////////
		// ֐

		//void Init();			// 
		bool Load( char *file );	// t@Cǂݍ
		bool Save( char *file );	// t@Cۑ

		bool PosSet( XYZ );			// W
		bool PosSet( float x, float y, float z );

		bool AngSet( XYZ );			// px
		bool AngSet( float x, float y, float z );

		bool AngAdd( XYZ );			// ݂̊px{
		bool AngAdd( float x, float y, float z );

		bool SizeSet( XYZ );		// TCY
		bool SizeSet( float x, float y, float z );

		bool Light( BOOL );			// CgvZEȂ
		bool Motion( int );			// Đ郂[VXgݒ
		//bool NormalFlag( BOOL );	// @vZEȂ
		//bool NormalType( int );		// @vZ^Cv ( J )
		//bool VB_Type( int );		// ua^Cv
		//bool ShadowLoad( char *file );  // VhEp|Sf[^ǂݍ

		bool PartsCopy( int s, int e );
		bool PartsDelete( int );
	};

	void ObjInit3(int,int);

	bool YJO_Load( int, char* );
	bool YJO_Save( int, char* );

	bool ObjPolyLoad( int, int, char *file );
	//BOOL PolyObjSave( int, int, char *file );

	void ObjAnimation3();
	void ObjKeyFrameCheck3(int);
	void ObjPolyDelete( int, int );
	void ObjSP3( int, int,  int, float );
	void ObjStudioInit();

	XYZ ObjMatSetVtx( int obj, int pa );
	XYZ ObjMatVtx( int obj, int pa );
}
