///////////////////////////////////////////////////////////////////////
// Struct.h

#pragma once

namespace YJ_Lib
{
	struct XY {
		float x, y;
	};

	struct XYZ {
		float x, y, z;
	};

	struct XYZW {
		float x, y, z, w;
	};

	struct COLOR {
		float r, g, b, a;
	};

	struct UV {
		float u, v;
	};


	struct MATRIX {
		XYZW m[4];
	};

	struct BUF {
		char Buf[ BUF_MAX ];
	};


	// C
	struct LINE {
		XY start;
		XY end;
	};

	// ~
	struct CIRCLE {
		XY		pos;	// ~̒S
		float	r;		// a
	};
}
