///////////////////////////////////////////////////////////////////////
// YJCu wb_t@C ( YJ.h )
//
// ̃t@CҏWƁAɃrhs
// łȂȂꍇ܂̂łӉB
//
// X Ps ( http://yj-project.com/ )
//
///////////////////////////////////////////////////////////////////////

#pragma once

#include "Include.h"
#include "Define.h"
#include "Enum.h"			// enum
#include "Struct.h"			// struct

#include "CharaObject.h"	// LN^[IuWFNg

#include "Collision.h"		// RW( 蔻 )
extern YJ_Lib::COLLISION Collision;

#include "File.h"			// t@CEtH_֘A
extern YJ_Lib::FILE File;

#include "Model2.h"			// 2Df ( YJB` )
extern YJ_Lib::MODEL2* Model2[ YJB_Max ];

#include "Model3.h"			// 3Df ( YJP ` )

#include "Obj2.h"			// 2DIuWFNg

#include "Program.h"		// YJ StudiovOҏW[hp
extern YJ_Lib::PROGRAM* Prog;

#include "YJ_Studio.h"		// YJ Studiop



#pragma comment( lib, "comctl32.lib" )
#pragma comment( lib, "winmm.lib" )


namespace YJ_Lib
{
	class YJL
	{
	public:

		/////////////////////////////////////////////////////////////////////////////////////////////
		// ͊֘A

		// L[{[h
		BOOL KeyFlag[256];
	

		// L[{[h(ǔ)
		enum KEY {
			KEY_OFF,	// ĂȂ
			KEY_PUSH,	// u
			KEY_ON,		// Ă
			KEY_RELEASE	// u
		};

		KEY Key[256];

		void KeyUpdate();



		// }EX
		BOOL MouseL, MouseM, MouseR;
		int  MouseX, MouseY;

		POINT MouseL_Up, MouseL_Down;
		POINT MouseM_Up, MouseM_Down;
		POINT MouseR_Up, MouseR_Down;



		// tF[hCEtF[hAEgp
		struct FADE
		{
			float Value;
			float Add;

			void In(float);
			void Out(float);
			void Set(float);

		} Fade;





		////////////////////////////////////////////////////////////////////////////////////////////
		// ϐ

		HINSTANCE hInst;

		bool loading;	// true:[h

		// ҏW[hœH
		BOOL StudioFlag;
		BOOL Studio[ ModeMax ];		// ҏW[hœH
	
		BOOL WinCenter[ ModeMax ];	// TRUEȂ640_480ɕ\

	
		WINDOWS_VERSION WinVer;		// Windows̃o[W

		bool AntiAlias;
		BOOL WinAdjustmentFlag;		// WinSizeɉāA2D\TCY𒲐



		int Mode;
		int OldMode;
		int PlayMode;
		int OldPlayMode;

		int SubMode;
		int SubOldMode;


		int a;	// :YJB֘AŎgĂ̂ڐA
		int b, g, k, ob, t, v;	// 

		BOOL MemMaxFlag;	// eIndexMaxmۂ





		char folder_exe[256];		// ÑtH_
		char folder_data[256];		// DatatH_

		char RenderFileName[256];	// _Op
		int  RenderStep;
		int  RenderS, RenderE;

		bool rendering_flag;		// Render()H



		int FillMode[ ModelMax3 ];	// Ƃŏ

		float LibFontSize;			// tHgTCY

		BOOL BgmFlag;
		char BgmFile[256];

		BOOL NextYJ_Flag;
		char NextYJ_File[256];

		COLOR Ambient;

		int BackColorR, BackColorG, BackColorB;

		int SceneDrawX,	 SceneDrawY;	// XRA ̍W
		int MovieMouseX, MovieMouseY;


		// Model2p
		BOOL			 Model2_Flag[ YJB_Max ];
		MODEL2::KEY_NODE YJB_MotionBoneBuf[ BoneMax ];  // [V obt@p


		// Model3p
		//MODEL3::KEY_NODE			MotionBoneBuf;				// [V {[ obt@p
		MODEL3::KEY_NODE			MotionBoneBuf[ BoneMax ];	// [V {[ obt@p

		MODEL3::ML_DATA::GROUP::KEY	MotionGroupBuf[ KeyMax ];	// [V O[v obt@p


		// Obj2p
		int YJA_Status;				// 0 ~  1 Đ  2 ĐI
		OBJ2::KEY_NODE YJA_KeyBuf;	// IuWFNgp
		

		// Obj3p
		BOOL Obj3_Flag[ ObjMax3 ][ ObjPartsMax3 ];			// 0 S̗p  1ȏ͊eIuWFNgp

		// DrawGroupɓo^ɂ͕Kv
		//int	Obj3_ObjectID[ ObjMax3 ][ ObjPartsMax3 ];	// Obj3pIuWFNgID

		//	MODEL3 *ObjP[ ObjMax3 ][ ObjPartsMax3 ];		// Obj3pff[^
		// ff[^烂fIDɕύX
		int	Obj3_ModelID[ ObjMax3 ][ ObjPartsMax3 ];		// Pbj3pfID

		int ObjStatus3;		// 0 ~  1 Đ  2 ĐI


		// }`Xbh
		CRITICAL_SECTION cs;
		

		// CPU Info
		struct CPU_INFO {

			short LogicalCoreNum;	// _RA( Pen4nCp[XbhCore2Duȍꍇ 2 ɂȂ܂BQuad 4 HHH )
			short PhysicalCoreNum;	// RA( }U[{[hCPU𕡐ZbgłꍇQȏɂȂHHH )

			void Check();

		} CPU_Info;


		// GPU Info
		struct GPU_INFO {

			char Name[ BUF_MAX ];	// rfIJ[h

			short GeForce;	// 0->GeForceÂ  1->GeForce1(2)  3->GeForce3(4)   5->GeForceFX or Radeon9500ȏ   6->GeForce6200ȏ(DirectX 9.0c)Ή

			bool AntiAlias;	// A`GCAX(4 Sample)

			short VertexShaderVersion;	// _VF[_[
			short PixelShaderVersion;	// sNZVF[_[

			int VertexBlendMatrices;
			int VertexBlendMatrixIndex;
			int PrimitiveCount;
			int VertexIndex;

		} GPU_Info;

		

		/////////////////////////////////////////////////////////////////////
		// Shader

		class Shader
		{
		public:

			enum DRAW_TYPE {
				DRAW_TYPE_NORMAL,		// W`
				DRAW_TYPE_MONOCHROME,	// mN[`
				DRAW_TYPE_SEPIA,		// ZsA`
				DRAW_TYPE_REVERSE,		// F]`
				DRAW_TYPE_SHADE,		// ڂ`
				DRAW_TYPE_MOSAIC,		// UCN`
				DRAW_TYPE_YURAYURA,		// `
				DRAW_TYPE_MAX
			};
		
			int		draw_type;		// `^Cv

			float	bloom_power;	// Bloom̋

			float	op[3];			// ėpIvV


			//
			Shader();

			int  DrawTypeGet();			// `^Cv擾
			void DrawTypeSet( int );	// `^Cvݒ

		} shader;



		////////////////////////////////////////////////////////////////////////////////
		// YJ Studiop  ړ

		YJ_Lib::Studio studio;

		WIN W[ ModeMax ][ WinMax ];

		// ĐvCp
		BOOL PlayFlag;			// ĐH
		BOOL PlayLoopFlag;
		int  PlayS, PlayE;

		int EditMouseX, EditMouseY;
		int k_scene;
		int vvs;				// ǂ̕ɕ`H0`3

		BOOL LightFlag;			// S̃CgvZtO

		
		int WinSU[ ModeMax ];	// qWin

		// ۑȂf[^
		int WinDraw;			// `悵ĂWinNo
		int WinAct;				// ANeBuWinNo

		BOOL WinFlipFlag;		// YJ.Lib łFlipݒł悤

		int WinX;				// WindowSize
		int WinY;
		int WinCX;				// S
		int WinCY;
		int WinX4;				// ŜP̃TCY
		int WinY4;
		float WinScaleX;		// WinSizeɍ킹āAC[Wg\p
		float WinScaleY;

		TREE Tree[ TreeMax ];
		int TreeSU;
		int TreeNo;
		int TreeNoK;			// I
		int TreeWY;				// c[c
		int TreeWinSX;
		int TreeWinSY;
		int TreeWinEX;
		int TreeWinEY;
		int TreeMouseX;
		int TreeMouseY;
		int TreeDrawSX;

		int DlgX, DlgY;

		int YJEP_Status;		// 0 ~  1 Đ  2 ĐI



		/////////////////////////////////////////////////////////////////////////////////////////////
		// ֐

		void Animation();

		void AntiAliasSet( bool );	// A`GCAXOnOff

		bool AVI_RecordStart( char*, int );	// AVI^Jn ( t@C, bԃR}(1`60) )
		void AVI_RecordEnd();				// AVI^I

		void BackColor( int, int, int );	// wiF

		BOOL bActiveGet();
		BOOL bReadyGet();

		void BoneAnimation();			// [VvZ

		bool CPU_PossessionGet();		// CPULԂ擾
		void CPU_PossessionSet(bool);	// CPULݒ

		void DisplayMode( int &x, int &y );

		HRESULT DrawFrame();		// `揈

		void DxWinSizeSet();

		void FaceMaxSet(int);		// ő嗘p|S

		int FPS();					// PbԂ̕`
		int FreeMem();				// 󂫃e


		void FrameTimeReSet();		// ďɎsāA1t[̎Ԃ̌vZ𒲐


		int ScreenX();				// EBhETCY擾
		int ScreenY();


		int	Random( int );			// 0`32768̃_
		float RandomF( float );		// 5.3̐xfloat_


		// z[y[W֘A
		void HomePage( char* );		// z[y[W\

		char HP_MY[ BUF_MAX ];



		char* String( char* );		// ( ăZbǵAsOFREE() )

		bool testString( char**, char* );	//  FREE()s




		void MesBox( char* );



		// }gNX(s)֘A
		void MtxInit( MATRIX *m );						// 

		void MtxPos( MATRIX *dest, XYZ xyz );			// ړs
		void MtxSize( MATRIX *dest, XYZ xyz );			// gks
		void MtxRotX( MATRIX *dest, float rot );		// w]s
		void MtxRotY( MATRIX *dest, float rot );		// x]s
		void MtxRotZ( MATRIX *dest, float rot );		// y]s
		void MtxMake( MATRIX *dest, XYZ xyz, XYZ rot, XYZ size );	// }gNX쐬

		void MtxMtx( MATRIX *dest, MATRIX src1, MATRIX src2 );		// s ~ s
		void MtxVec( XYZ *dest, XYZ src1, MATRIX src2 );			// xNg ~ s
		void MtxCopy( MATRIX *dest, MATRIX *src );		// sRs[
		void MtxShadow( MATRIX *dest, XYZ v );			// sVhE }gNX
		void MtxInverse( MATRIX *dest, MATRIX src );	// ts
		void MtxSlerp( MATRIX &dest, MATRIX a, MATRIX b, float f );

		// Deviceɐݒ肳ĂMatrix擾
		MATRIX WorldMtxGet();
		MATRIX ViewMtxGet();
		MATRIX ProjectionMtxGet();

		MATRIX WorldViewProjectionMtxGet();

		XYZ ScreenFrom3DPosGet( int x, int y );	// XN[W3DW擾


		////////////////////////////////////////////////////////////////////
		// CurvedSurface (  Ȗʃf )

		struct CurvedSurfaceModel {

			MODEL3 *model;

			bool Init();
			void Get();		// Model3 -> CurveSurfaceModel
			void Set();		// CurveSurfaceModel -> Model3

			bool Direction();

		} curved_surface_model;

		void PatchDraw( float, float, float,  float, float, float,  int,int,int,int,  int,int,int,  float, float,
						float, float, float,  float, float, float,  int,int,int,int,  int,int,int,  float, float,
						float, float, float,  float, float, float,  int,int,int,int,  int,int,int,  float, float,
						short );



		// NH[^jI֘A ( Quaternion )
		void QtnInit( XYZW &q );			// 
		void QtnAdd( XYZW &q, XYZW s );		// Z
		void QtnSub( XYZW &q, XYZW s );		// Z
		void QtnMtx( MATRIX &m, XYZW q );
		void MtxQtn( XYZW &q, MATRIX m );
		void QtnQtn( XYZW &d, XYZW s );
		void RotQtn( XYZW &q, XYZ v, float r );
		void QtnAxis( XYZ &v, float &ang, XYZW q );
		void AxisQtn( XYZW &q, XYZ v, float ang );
		void QtnNormalize( XYZW &q );
		void QtnInverse( XYZW &d, XYZW s );
		void QtnMake( MATRIX *dest, XYZ pos, XYZW rot, XYZ size );
		void QtnSlerp( XYZW &q, XYZW a, XYZW b, float f );


		// xNg
		void VecNormalize( XYZ &v );

		// O
		XYZ CrossProduct( XYZ, XYZ );

		// 
		float DotProduct( XYZ, XYZ );



		void PolyRenderFlag( BOOL );		// |S`悷EȂ


		void Rendering( char* );			// BMPۑ ( ʑS )
		void RenderingSize( char*, RECT );	// BMPۑ ( w͈ )


		//  eNX`Ƀ_O
		int RenTexInit( int WinNo, int Type, int ID, int x, int y );
		void RenTexDraw(int);
		void RenTexDxInit( int i );
		void RenTexDxInitALL();
		void RenTexDxRelease(int);
		void RenTexDxReleaseALL();



		XYZ ScreenPos( XYZ );		// 3DW2DW(Zs)擾


		// 3DVhE
		COLOR Shadow3D_ColorGet();
		void Shadow3D_ColorSet( COLOR );
	
		void Shadow3D_ReSize();


		void TexDataGet2(int);
		int  TexDataGetRGB2(int,int);

		void TexDataGet3(int);
		int  TexDataGetRGB3(int,int);

		void TexSet(int);				// eNX`؂ւ


		HRESULT ToggleFullscreen();		// EBhE[h <--> tXN[[h؂ւ


		void VB_ObjSet();

		double Ver();		// YJCũo[W
		char* VerChar();	// o[W

		void VramInfo( int *total, int *free, int *used );	// VRAM̏

		void WinSize();
		


		////////////////////////////////////////////////////////////////////
		// vOҏW[h

		void YJS_Init();
		void YJS_HensuInit();

		YJ_Lib::PROGRAM* YJS_malloc();	// YJS_ALL
		void YJS_SubMalloc(int);		// YJS Tu֐

		void YJS_Run();
		void YJS_SubAdd( char* );
		void YJS_ProgSU_Check(int);

		void YJS_Load( char* );
			

		/////////////////////////////////////////////////////////////////////////////////////////////
		// ̑
	
		// [VRot̂
		BOOL YJM_Load( int, char* );
		BOOL YJM_Save( int, char* );


		void MotionKeyFrameCheck2(int);
		void MotionSP2( int, int, int, float );




		//
		void DxTexCreate2( int, int, char * );

		void ObjDxTexCreate3( int, int, int, char * );
		void DxTexCreate3( int, int, char * );

		void TexUV_Set2( int );
		void TexUV_SetGroup2( int, int );

		void TexUV_SetGroup3( int, int );

		void YJP_MotionCopy( int, char* );  // Rs[, t@C ( {[EGCg[VRs[ )

		float Spline( float,float,float,float, float );


		// 2Df
		// Motion
		XYZ BoneMatVtx2( int p, int b, XYZ xyz );

		// Set
		XYZ BoneMatSetVtx2( int p, int b, XYZ xyz );


		//
		void Set_fps_time();
		void Set_fps_time_flag(BOOL);


		bool DrawCheck();

		void DrawModeSet( DRAW_MODE );	// `惂[hZbg
		void DrawModeRenderStateSet();	// `惂[hύX

		// }bv@}bvɃRo[g
		void HeightmapToNormalmap();



		// Pt[
		double UpdateTimeGet();		// XVԎ擾
		double RenderTimeGet();		// `掞Ԏ擾

		// t[[g l:60
		int  FrameRateGet();
		void FrameRateSet( int rate );

		// ҂E҂Ȃ
		bool V_SyncGet();			// 60FPSȏ͋
		void V_SyncSet(bool);		// ̃Xs[h[h   eBAOڗH

		// t[XLbv
		bool FrameSkipGet();
		void FrameSkipSet( bool flag );

		// t[Xs[h 0.5f:X[  1.0f:W  2.0f:
		float FrameSpeedGet();
		void  FrameSpeedSet( float speed );

		// 1t[̍Ōő҂E҂Ȃݒ
		bool FrameWaitGet();
		void FrameWaitSet( bool flag );


		int  RunLoopCountGet();
		void RunLoopCountSet(int);

		int RunSU( double* );



		void Line( int,int, int,int, int,int,int,int );
		void Dot( int,int, int,int,int,int );

		void DrawWaku( int sx, int sy,  int ex, int ey,  int r, int g, int b, int a );
		void DrawTypeSet(int);

		void EffectMtx( float, float, float,  float, float, float,  float, float, float );

		int RenderModelNum();	// `悵f
		int RenderPolyNum();	// `悵|S

		// J[L[̐ݒ( 0,0,0,0̏ꍇAJ[L[ )
		void ColorKeySet( int r, int g, int b, int a );

		// ݃EBhE[hH  true:EBhE[h  false:tXN[[h
		bool IsWindowMode();


		// O EBhE
		void LogInit();						// 
		void Log( char *format, ... );		// bZ[Wo
		void LogDebug( char *format, ... );	// bZ[Wo( Debugrĥ )
		void LogWinSize( int x, int y, int sx, int sy );

		//void LogFileInit();						// Ot@C( LibɈړ )
		//void LogFile( char *format, ... );		// t@CɃbZ[Wo



		////////////////////////////////////////////////////////////////////////////////////////////
		// System

		YJL();
		~YJL();

		bool LibInit( HINSTANCE );		// YJCu ( hInst )
		void LibMainProc();

		void Draw2D();	// 2D`
		void Draw3D();	// 3D`
		void Update();	// [v

		static void WinProc( HWND, UINT, WPARAM, LPARAM );	// bZ[W
	};
}

using namespace YJ_Lib;

extern YJL YJ;


#include "Bgm.h"		// BGM
extern DIRECT_MUSIC DirectMusic;

#include "Camera.h"		// J
extern CAMERA Camera;

#include "Cnv.h"		// Ro[g

#include "Draw2.h"		// 2D`
extern DRAW2 Draw2;

#include "Draw3.h"		// 3D`
extern DRAW3 Draw3;


#include "Effect.h"		// GtFNg	
extern EffectParticleData*	EPD[ EffectParticleMax ];
extern EffectParticle		EP[ EffectParticleMax ];
extern EFFECT				Effect;

#include "Font.h"		// tHg
extern FONT Font;

#include "Image.h"		// C[W(2D)
extern IMAGE Image[ ImageMax ];

#include "ImageEx.h"	// Imageǔ
extern IMAGE_EX ImageEx;

#include "Layout.h"		// CAEg ( YJL` )
extern LAYOUT Layout;

#include "Light.h"		// Cg
extern LIGHT Light;

#include "Map2.h"		// 2D}bv
extern MAP2* Map2;

#include "Map3.h"		// 3D}bv

#include "MapData.h"	// }bvǗ

#include "Media.h"		// MCI𗘗pāABGMʉE[r[Đ
extern MEDIA Media;

#include "Movie.h"		// A^C[r[( YJV` )
extern MOVIE Movie;

#include "Obj3.h"		// 3DIuWFNg( YJO` )
extern OBJ3* Obj3[ ObjMax3 ];

#include "Option.h"		// IvV
extern OPTION Option;


#include "Wave.h"		// ʉ ( *.wav ) DirectSoundɑΉĂ܂B
extern WAVE Wave;



//
extern HWND		hWnd;
extern float	T;		// Ԃ̗
