///////////////////////////////////////////////////////////////////////
// Enum.h

#pragma once

namespace YJ_Lib
{
	enum DRAW_MODE {
		DRAW_MODE_NORMAL,	// W`
		DRAW_MODE_ADD,		// Z
		DRAW_MODE_SUB,		// Z
		DRAW_MODE_MULTI		// Z
	};

	enum IMAGE_TYPE {
		IMAGE_TYPE_RGB,		// eWrbg(O`QTT)~RQSrbg
		IMAGE_TYPE_RGBA		// eWrbg(O`QTT)~SRQrbg
	};

	// @̌vZ@
	enum NORMAL_TYPE {
		NORMAL_TYPE_DEFAULT,	// ʏ̖@vZ(ᑬ)
		NORMAL_TYPE_MATRIX,		// DEFAULTPO`RO(vZx܂)

	#ifdef TEST_NORMAL_TYPE
		NORMAL_TYPE_TEST		// J̐V@vZ
	#endif
	};

	// e̎
	enum SHADOW_TYPE {
		SHADOW_TYPE_NONE,				// eȂ
		SHADOW_TYPE_2D_CIRCLE,			// ۉe
		SHADOW_TYPE_2D_CIRCLE_LIGHT_DIR,// ۉe(Cǧ̉e)
		SHADOW_TYPE_2D_MODEL,			// f̌`Ő^ɉe
		SHADOW_TYPE_3D_SHADOWVOLUME,	// VhE{[
		SHADOW_TYPE_3D_SHADOWMAP		// VhE}bv
	};

	// VB( VertexBuffer )
	enum VB_TYPE {
		VB_TYPE_OFF,	// CPU`(Ɨ_) VRAMgpȂBP|SƂɕ`悷邽ߒᑬB
		VB_TYPE_CPU,	// CPU`(Ɨ_) VRAMgpȂBO[vʂɂ܂Ƃ߂ĕ`悷̂ŁAVB_TYPE_OFF 荂B
		VB_TYPE_ON,		// VB`(Ɨ_) rfIJ[h DirectX 9 ɑΉĂꍇ VB_TYPE_OFF 荂
		VB_TYPE_INDEX,	// VB`(L_) [V̏ꍇAVB_TYPE_ON 荂 ( HȂ̂Œ )
		VB_TYPE_GROUP,	// YJP 2009 ȏŎgpł鍂ȕ`GWł
		VB_TYPE_HLSL,	// HLSL_VF[_[𗘗pāA{[vZƕ`GPUŏ邽߃``BCgΉBShaderModeOFF̂݃{[vZfB
		VB_TYPE_BUMPMAP,		// ( J )ov}bsO
		VB_TYPE_BUMP_GROUND,	// ( J )ov}bsO n
		VB_TYPE_DISPLACEMENT,	// fBXvCXg}bsO
		VB_TYPE_CPU_INDEX	// ( J )L_
	};

	enum WINDOWS_VERSION {
		WIN_ERROR,	// ʕs\
		WIN_31,		// 3.1
		WIN_95,		// 95, 98, Me
		WIN_NT,
		WIN_2000,
		WIN_XP,
		WIN_VISTA,
		WIN_7,		// Windows7
		WIN_8,		// Windows8 or ʃo[W
		//WIN_8_1		// Windows8.1 or ʃo[W
	};


	/////////////////////////////////////////////////////////////////////////////////////////////
	// YJ Studiop enum

	enum MODE_TYPE {

		ModePreView,
		ModeFile,
		ModeImg,
		ModeLayout,
	
		Mode2,
			ModeObj2,
			ModeObjJoint2,
			ModePoly2,
			ModeTex2,
			ModeBone2,
			ModeWeight2,
			ModeMotion2,

		Mode3,
			ModeObj3,
			ModeObjJoint3,
			ModePoly3,
			ModeTex3,
			ModeBone3,
			ModeWeight3,
			ModeMotion3,

		ModeParticle,
		ModeEffect,
		ModeMap2,
		ModeMap3,	//ModeColi,
		ModeMapMan,
		ModeMovie,
		ModeProg,

		ModeMax
	};


	enum WIN_TYPE {
		WinTypeMain,
		WinTypeSub,
		WinTypeKey
	};

	enum VIEW_TYPE {
		ViewMain,	// Pers
		ViewFront,	// 
		ViewTop,	// 
		ViewSide,	// 
		ViewPers	// SubWinPers`
	};




	enum EFFECT_TYPE {
		EffectTypeProg,
		EffectTypeYJA
	};

	enum EFFECT_TYPE_PROG {
		ETP_1,
		ETP_2,
		ETP_3,
		ETP_3_Free,
		ETP_4,
		ETP_4_Free,
		ETP_Circle
	};

	enum DRAW_TYPE {
		DrawTypeNone,
		DrawTypePoint,
		DrawTypeWire,
		DrawTypeFlat,
		DrawTypeGouraud,
		DrawTypePatch,
		DrawTypeMax
	};


	enum PLAY_MODE_TYPE {
		PlayModePreView,
		PlayModeLayout,
		
		PlayModeObj2,
		PlayModeMotion2,

		PlayModeObj3,
		PlayModeMotion3,

		PlayModeParticle,
		PlayModeEffect,

		PlayModeMovie,

		PlayModeProg,

		PlayModeRendering,	// BMP
		PlayModeAVI,		// AVI

		PlayModeBgm
	};



	// ProgType
	enum PROG_TYPE {
		PT_None,
		PT_Label,		// x
		PT_Var,			// ϐ 錾
		PT_VarSub,		// ϐ  ( Substitution )
		PT_VarCal,		// ϐ vZ ( Calculation )

		PT_If,			// }

		PT_Font,		// \
		PT_ImgLoad,		// C[W
		PT_ImgDraw,

		PT_PolyLoad,	// 3D
		PT_PolyPos,
		PT_PolyAng,
		PT_PolySize,

		PT_PolyLight,		// Cgf -> 0 Ȃ  1 
		PT_PolyMotion,		// [VXg
	//		PT_PolyMotionFrame, // FrameNo
	//		PT_PolyMotionKey,	// KeyNo
		PT_PolyVB,			// VB_GPU_TYPE  0 OFF  1 ON  2 Index  3 GPU

		PT_CameraS,		// J
		PT_CameraE,

		PT_LightPos,	// Cg

		PT_Key,			// L[{[h

		PT_Folder,		// tH_ύX

		PT_Go,			// Wv
		PT_ScreenDraw	// ʕ`
	};
}
