///////////////////////////////////////////////////////////////////////
// Model2.h  2Df ( YJB` )

#pragma once

namespace YJ_Lib
{
	struct MODEL2
	{
		// [VXg
		struct MOTION_LIST {
			BOOL Flag;
			BOOL Repeat;
			char Name[ BUF_MAX ];
			int  Frame;
		};


		// eNX`
		struct TEX {
			BOOL Flag;
			char File[ BUF_MAX ];
			int  x, y;	// TCY
		};


		// O[v
		struct GROUP {

			char Name[ BUF_MAX ];

			int TexNo;

			float r, g, b, a;

			int DrawType;  // 0 \  1 |Cg  2 C[  3 tbg  4 O[[  5 Ȗ


			// UV
			BYTE  uv_type;	// 0   1   2   3 ~  4   5 eʒP   10 tuҏW
			float x, y, sx, sy;


			BOOL MirrorFlag;
		};





		
		// _ P̏
		struct VTX {
			unsigned short v;	// _No
			unsigned short c;	// FNo
			unsigned short t;	// UVNo

			// ۑȂf[^
			//bool	edit_flag;		// ҏWp ( EditVڐA )
		};

		// |S P̏
		struct FACE {
			BOOL Flag;
			BYTE VtxSU;			// _
			VTX	 V[ VtxMax ];	// _
			int	 Group;			// O[vNo

			// ۑȂf[^
			bool edit_flag;		// ҏWp
		};


		// EGCg
		struct WEIGHT {
			unsigned short b0;	// {[No0
			unsigned short b1;	// {[No1
			float w;			// EGCg 0 x[X
			BOOL Auto;			// vZ FALSE Ȃ  TRUE 
		};





		struct KEY_NODE {

			int Frame;

			XY    Pos;
			float Ang;
			XY    Size;
		};


		struct KEY_MOTION_LIST {

			int KeySU;

			KEY_NODE *N;

			// ۑȂf[^
			int N_Mem;
		};


		struct BONE {

			char Name[ BUF_MAX ];	// {[

			KEY_NODE Base;	// x[X

			int Parent;		// e{[No
			int Child;
			int Sibling;
			int Dan;

			//KEY_MOTION_LIST *K;
			KEY_MOTION_LIST *ML;


			////////////////////////////////////////////////////////////
			// ۑȂf[^

			// Bonep
			XY    PosPoint;
			float AngPoint;
			XY    SizePoint;

			int   KeyNo;	// ߂L[t[
			float KeyF;		// L[t[̊Ԃ̏ꏊ



			// YJ Studio Editp
			BOOL OpenFlag;
			BOOL OpenDrawFlag;	// ۂɕ\H
		};



		int Ver;	// o[W

		char File[ BUF_MAX ];

		// |Sf[^
		unsigned short v_num;	// _
		unsigned short c_num;	// F
		unsigned short t_num;	// eNX`

		XY	  *v;	// _
		COLOR *c;	// F
		UV	  *t;	// eNX`

		WEIGHT *w;	// EGCg

		// Indexf[^
		int	  FaceNum;
		FACE *F;




		// eNX`
		int	TexNum;
		TEX	Tex[ TexMax ];

		// O[v
		int	  GroupNum;
		GROUP G[ GroupMax ];


		COLOR Color;	// S̃J[



		// [VXg
		int			ML_SU;
		MOTION_LIST	ML[ MotionListMax2 ];
		int			ML_Mem;


		// ʉ
		int  WaveSU;
		char WaveFile[ WaveMax ][ BUF_MAX ];

		int  WaveNo[ KeyMax ];




		BOOL LightFlag;
		BOOL C_Flag;	// O[vJ[ or _J[

		BOOL  EdgeFlag;	// GbWtO
		float EdgeSize;	// GbW̑




		/////////////////////////////////////////////////////////////////////
		// [V

		// {[֘A
		int BoneNum;

		BONE		B[ BoneMax ];
		//KEY_NODE	Base[ BoneMax ];	// x[X


		// [Ṽ^Cv  0 JNJN  1 X[Y
		int AniTypePos;
		int AniTypeAng;
		int AniTypeSize;







		///////////////////////////////////////////////////////////////////////
		// VhE֘A
/*
		int ShadowType;  // 0 Ȃ  1 ۉe(Ή)  20 QcVhE  21 ΂߂QcVhE  30 RcVhE

		// QcVhEp
		float ShadowY;	// QcVhÊxW

		XYZ Shadow;	// ΂߂QcVhẺě



		// VhEp|Sf[^u
		struct SHADOW_VTX {
			float x, y, z;
			int VtxNo;		// f[^̋߂_No_{[vZp
		};

		//typedef struct SHADOW_FACE {
		struct SHADOW_FACE {
			BOOL	Flag;
			BYTE	VtxSU;		// _
			VTX	V[ VtxMax ];	// _
			//int	  Group;		// O[vNo
		};


		BOOL ShadowPolyUse;  // VhEp|Sf[^𗘗pāAVhE`悷H

		//unsigned short Shadow_v_su;		// VhEp_
		int			 Shadow_v_su;		// VhEp_
		SHADOW_VTX	*Shadow_v;		// VhEp|Sf[^u


		// Indexf[^
		//unsigned short ShadowFaceNum;
		int			 ShadowFaceNum;
		SHADOW_FACE	*ShadowF;



		// EGCgvZ
		XYZ *ShadowWV;
		XYZ *ShadowWN;
*/


		/////////////////////////////////////////////////////////////////
		// t@CɕۑȂAꎞIȃf[^

		int ID;

		BOOL Flag;			// YJP LoadFlag
//		BOOL NormalFlag;	// @vZ
		BOOL DrawFlag;		// `
		BOOL VB_DrawFlag;	// VB
		BOOL VB_SetFlag;

		BOOL BoneCalFlag;	// {[vZH Calculation



		// {[EGCgvZp
		XYZ BoneCenter[ BoneMax ];
		int BoneCenterSU[ BoneMax ];


		// EGCgvZ
		XY *WV;
//		XY *WN;





		int FillMode;	// 0 |Cg  1 C  2 hԂ  3 EGCg


		
		int f;	// FrameNo
		float f_add;	// t[Zp

		//int MotionListNow;  // ݂̃[VXgNo
		int ML_Now;  // ݂̃[VXgNo
		//int m;	// [VXg

//		BOOL ReLoop;
//		int	 LoopS, LoopE;

		// tbVp
//		BOOL  FlashFlag;
//		BOOL  FlashTexFlag;
//		COLOR FlashColor;
//		int   FlashTime;

		// YJCup
		XY		ModelPos;
		float	ModelAng;
		XY		ModelSize;





		/////////////////////////////////////////////////////////////////////////////////
		// ֐

		BOOL Load( int, char *file );	// t@Cǂݍ
		BOOL Save( int, char *file );	// t@Cۑ

		BOOL Pos( XY );			// W
		BOOL Ang( float );		// px
		BOOL AngAdd( float );	// ݂̊px{
		BOOL Size( XY );		// TCY

	};


	void Model2_Init(int);		// 
	void Model2_Delete(int);	// 

	void YJB_BoneAnimation();
	void YJB_DeleteALL();

	BOOL YJB_Load( int, char* );
	BOOL YJB_Save( int, char* );
	

	// ჌x
	MODEL2*	Model2_InitA();
	MODEL2*	Model2_DeleteA( MODEL2* );
}
