///////////////////////////////////////////////////////////////////////
// Model3.h

#pragma once

namespace YJ_Lib
{
	struct MODEL3
	{
		// _ P̏
		struct VTX {
			int v;	// _No
			int n;	// @No
			int c;	// FNo
			int t;	// UVNo

			// ۑȂf[^
			bool	edit_flag;		// ҏWp ( EditVڐA )
		};

		// |S P̏
		struct FACE {
			BYTE	VertexNum;			// _

#ifdef VERTEX_5OVER
			VTX		V[16];			// _
			//vector<VTX>	V;		// _
#else
			VTX		V[ VtxMax ];	// _
#endif
			
			int		Group;			// O[vNo

			// ۑȂf[^
			XYZ		n;				// ʖ@
			bool	edit_flag;		// ҏWp
		};

		// EGCg
		struct WEIGHT {
			BYTE b0;	// {[No0	unsigned short
			BYTE b1;	// {[No1	unsigned short
			float w;	// EGCg 0.0fb0 1.0fb1
			bool Auto;	// vZ		BOOL
		};

		// eNX`
		struct TEX {

			// RXgN^
			TEX(){
				Init();
			}


			BOOL Flag;
			//bool flag;

			//char file[ BUF_MAX ];
			FileData file;

			int  x, y;	// TCY


			////////////////////////////////////////////////////////////////
			// ֐
		
			void Init();
		};


		// O[v
		struct GROUP {

			// RXgN^
			GROUP(){
				Init();
			}


			char Name[ BUF_MAX ];

			int TexNo;

			float r, g, b, a;

			int DrawType;  // 0 \  1 |Cg  2 C[  3 tbg  4 O[[  5 Ȗ


			// UV
			BYTE  uv_type;	// 0   1   2   3 ~  4   5 eʒP   10 tuҏW
			float x, y, sx, sy;

			BOOL BackFlag;	//  ( VB_TYPE_OFF̎ʂ\܂ )

			// 2002.10 ǉ
			int  PatchSU;
			BOOL MirrorFlag;

			// 2003.03 ǉ
			BOOL SpecularFlag;	// XyL[( ˌ )
			int  SpecularR;		// GeForce3 ȂFݒł܂
			int  SpecularG;		// GeForce1,2MX,4MXƐFfȂ OnOff̂
			int  SpecularB;



			// 2008 ǉ
			bool tex_flag;			// ʏeNX`( TexNo0̃eNX`ȂɂeNX`ǂݍށRo[^[C邱 )

			short draw_mode;		// 0:NORMAL(ʏ) 1:ADD(Z) 2:SUB(Z) 3:MUL(Z)

			bool  shadow_flag;		// e\ ShadowMapp(  )
			short shadow_mode;		// gp

			bool  bloom_flag;		// Ȕ
			float bloom;

			bool  glare_flag;		// Px߂  ~󔒌(Ԃ̃Cg)
			float glare;

			bool  bumpmap_flag;		// ov}bv
			short bumpmap_tex;		// TexNo

			bool  displacementmap_flag;		// fBXvCXg}bv
			short displacementmap_tex;		// TexNo
			float displacementmap_value;	// 
			
			bool  environmentmap_modoki_flag;	// }bvǂ( GoCg )
			short environmentmap_modoki_tex;	// ڂ荞ރeNX`w肷ꍇ  0 IuWFNg猩JŃ_Ô\tH

			bool  environmentmap_flag;	// }bv( GoCg )
			float environmentmap_value;	// 0.0f`1.0f 1.0fŉf荞100% CubeMap(Uʃ_O)

			bool  alpha_test_flag;		// At@eXg
			short alpha_test;

			bool  z_write_flag;			// Zobt@



			////////////////////////////////////////////////////////////////
			// O[vʃff[^

			//int v_num;	// _
			//int n_num;	// @
			//int c_num;	// _J[
			//int t_num;	// eNX`
			int index_num;

			XYZ	  *v;	// _
			XYZ	  *n;	// @
			COLOR *c;	// F
			UV	  *t;	// eNX`

			WEIGHT *w;	// EGCg

			// Indexf[^
			FACE *F;
			int	  FaceNum;


			//////////////////////////////////////////////////////////////
			// t@CɕۑȂf[^

			// EGCgvZ
			XYZ *WV;
			XYZ *WN;



			////////////////////////////////////////////////////////
			// JEEE

			XYZ base_pos;		// W

			XYZ BBoxMin, BBoxMax;	// O[vTCY( oEfBO{bNX )


			// UVAj[V
			bool	uv_anim_flag;
			float	uv_anim_move_u;	// ړ
			float	uv_anim_move_v;
			double	uv_anim_now_u;	// ݂̈ړl
			double	uv_anim_now_v;


			////////////////////////////////////////////////////////////////
			// ۑȂf[^

			bool draw_flag;		// \E\



			////////////////////////////////////////////////////////////////
			// ֐

			void Init();
		};

		
		// L[Pʂ̐ݒ
		struct KEY_NODE
		{
			int	 Frame;

			XYZ  Pos;
			XYZW Qtn;
			XYZ  Size;


			KEY_NODE()
			{
				Frame = 0;

				Pos.x = 0.0f;
				Pos.y = 0.0f;
				Pos.z = 0.0f;

				Qtn.x = 0.0f;
				Qtn.y = 0.0f;
				Qtn.z = 0.0f;
				Qtn.w = 1.0f;

				Size.x = 1.0f;
				Size.y = 1.0f;
				Size.z = 1.0f;
			}
		};


		// [VXg
		struct ML_DATA {

			ML_DATA(){
				sprintf( Name, "[V" );
				Frame		= 60;
				repeat		= true;
				next_motion	= -1;

				memset( &G, 0, sizeof(GROUP) * GroupMax );
			}

			char  Name[ BUF_MAX ];
			int   Frame;
			bool  repeat;		// s[gĐH
			short next_motion;	// [VĐAقȂ郂[VXgĐB



			// ̏ꏊֈړ
			struct GROUP {

				struct KEY {

					int frame;

					short ani_type;	// Aj[V@  0 |Cg 1 
					short tex_no;
					float r, g, b, a;

					// ʉ
					//int  WaveNo[ KeyMax ];	// ֈz

				} K[ KeyMax ];

				int key_num;


				//////////////////////////////////////////////////////////////////
				// ۑȂf[^

				KEY point;

				int   KeyNo;	// ߂L[t[
				float KeyF;		// L[t[̊Ԃ̏ꏊ

				int key_mem;

			} G[ GroupMax ];
		};


		// {[
		struct BONE {

			char Name[ BUF_MAX ];	// {[

			KEY_NODE Base;	// x[X( pos, rot, size )

			int Parent;		// e{[No
			int Child;
			int Sibling;
			int Dan;


			// [VXgʃL[
			struct ML_KEY {
				vector<KEY_NODE> K;
				int				 K_Num;
				void KeyMemReSize(int);	// TCYύX

				ML_KEY()
				{
					K_Num = 0;
				}
			};
			vector<ML_KEY>	ML;
			//int				ML_Num;		// p->ML_DataNumg
			void ML_MemReSize(int);	// TCYύX


			////////////////////////////////////////////////////////////
			// ۑȂf[^

			// YJ Studio Editp
			BOOL OpenFlag;
			BOOL OpenDrawFlag;	// ۂɕ\H

			MATRIX	SetMatrix;	// Set
		};


		int Ver;	// o[W

		FileData file;

		// |Sf[^
		int v_num;	// _
		int n_num;	// @
		int c_num;	// _J[
		int t_num;	// eNX`

		XYZ	  *v;	// _
		XYZ	  *n;	// @
		COLOR *c;	// F
		UV	  *t;	// eNX`

		WEIGHT *w;	// EGCg

		// Indexf[^
		vector<FACE> F;
		int			 FaceNum;
		void FaceMemReSize(int);	// TCYύX


		// O[v
		vector<GROUP>	G;
		int				GroupNum;

		// eNX`
		vector<TEX>	Tex;
		short		TexNum;
		
		// fBXvCXg
		//Groupݒ̕g悤ɕύX
		short displacement_no;
		float displacement_height;


		// {[֘A
		BONE B[ BoneMax ];
		int BoneNum;


		short division;	//  ( Ȗʃ[hƃfBXvCXgp )
		
		COLOR ModelColor;	// S̃J[


		// ʉ
		int  WaveSU;
		char WaveFile[ WaveMax ][ BUF_MAX ];

		int  WaveNo[ KeyMax ];


		BOOL LightFlag;	// CgvZ
		BOOL C_Flag;	// FALSE -> O[vJ[   TRUE -> _J[

		BOOL  EdgeFlag;	// GbWtO
		float EdgeSize;	// GbW̑


		///////////////////////////////////////////////////////////////////////////////////////////
		// [V֘A

		vector<ML_DATA> ML_Data;  // [VXg
		int				ML_DataNum;
		void ML_DataMemReSize(int);	// TCYύX


		// [Ṽ^Cv  0 JNJN  1 X[Y
		int AniTypePos;
		int AniTypeAng;
		int AniTypeSize;


		////////////////////////////////////////////////////////////////////////////////////////////////
		// VhE{[֘A
		
		SHADOW_TYPE ShadowType;

		// 2DVhEp
		float ShadowY;	// 2DVhÊxW
		float Shadow2D_Scale;

		XYZ Shadow;		// ΂2DVhẺě


		// VhE{[p|Sf[^u
		struct SHADOW_VTX {
			float x, y, z;
			int VtxNo;		// f[^̋߂_No_{[vZp
		};

		struct SHADOW_FACE {
			BYTE	VtxSU;			// _
			VTX		V[ VtxMax ];	// _
		};

		BOOL ShadowPolyUse;  // VhEp|Sf[^𗘗pāAVhE`悷H

		int			 ShadowVtxSU;	// VhEp_
		SHADOW_VTX	*ShadowV;		// VhEp|Sf[^u

		// Indexf[^
		int			 ShadowFaceNum;
		SHADOW_FACE	*ShadowF;

		// EGCgvZ
		XYZ *ShadowWV;
		XYZ *ShadowWN;



		//////////////////////////////////////////////////////////////////////////////////
		// t@CɕۑȂf[^

		int	id;

		bool flag;			// ɃtO( false: true: )
		bool load_flag;		// LoadItO
		bool use_flag;		// gԃtO

		bool draw_flag;		// `tO
		bool delete_flag;	// tO

		BOOL N_Flag;		// @vZ
		int  N_Type;		// @vZ^Cv


		BOOL BoneCalFlag;	// {[vZH Calculation

		// {[EGCgvZp
		XYZ BoneCenter[ BoneMax ];
		int BoneCenterSU[ BoneMax ];

		// EGCgvZ
//		XYZ *WV;	// 
//		XYZ *WN;	// 

		int		FillMode;	// 0 |Cg  1 C  2 hԂ  3 EGCg
		




		// oEfBO{bNX(Â)
		XYZ Min,	 Max;		// fTCY( őEŏ )
		XYZ BBoxMin, BBoxMax;	// fTCY( oEfBO{bNX )

		float	coll_r;		// L̔a

		bool	billboard;	// r{[h





		/////////////////////////////////////////////////////////////////////////////////
		// ֐

		MODEL3();		// RXgN^
		~MODEL3();		// fXgN^

		void Init();	// 

		bool Save( char *file );		// t@Cۑ

		bool UseState();				// gԁH flag ĂEload_flag ς ̏ꍇAtrueԂ

		bool Color( int,int,int,int );	// F
		bool DeleteFace(int);			// ʏ
		bool Division( bool n_flag = true );	//  bool:ɖ@vZH
		//bool Flash( int, int, BOOL, int,int,int,int );
		bool Light( bool );				// CgvZEȂ


		bool NormalFlag( bool );		// @vZEȂtO
		bool NormalType( int );			// @vZ^Cv ( J )
		bool Optimize();				// |Sf[^œK
		bool Decomposition();			// |Sf[^𕪉
		bool TexSet( int );	

		bool WaveLoad( int, char* );
		bool WavePlay( int );

		bool WeightAutoSet();			// EGCgvZ

		//
		bool BoneCopy( int s, int e );
		bool BoneDelete( int );

		// VhE{[p
		bool ShadowLoad( char *file );	// t@Cǂݍ

		void UV_Update();		// UVAj[VXV


		///////////////////////////////////////////////////////////////////////////////
		// ჌x֐

		bool BoneBaseMatrix();

		void CnvModelDivision();	// |Sf[^O[vʂɕ



		void ChildSiblingFromParent3();		// ParentChildSibling߂


		// J   bold:
		void Test_TexDraw( int tex_no, int bold, float u, float v, int r, int g, int b );
	};

	int		Model3_Create();		// 쐬
	MODEL3* Model3_Get(int);		// |C^擾
	int		Model3_UseNum();		// fgp̐擾
	int		Model3_Num();			// f擾

	bool Model3_Copy( int s, int e, bool mem_flag );	// ff[^Rs[ mem_flag:mۂ邩
	bool Model3_GroupCopy( int s_model, int s_group,  int e_model, int e_group );

	void Model3_Delete(int);		// f
	void Model3_DeleteALL();		// Sf


	// t@Cǂݍ
	int	Model3_Load( char *folder, char *file );	// return:id


	// 폜\
	int	Model3_Load( char *file );	// fileɃtH_܂܂ĂȂƌ듮삷\邽

	// IDwǂݍ
	int	Model3_Load( int id, char *file );
	int	Model3_Load( int id, char *folder, char *file );

	// }`Xbh֘A
	int	 Model3_LoadThread( char *folder, char *file );	// return:id
	void Model3_LoadWait( int id );	// ǂݍݏI܂őҋ@
	bool Model3_IsLoad( int id );	// t@CǂݍݏI`FbN
	void Model3_DeleteProc();		// s


//	MODEL3::KEY_NODE			MotionBoneBuf[ BoneMax ];	// [V {[ obt@p
//	MODEL3::ML_DATA::GROUP::KEY	MotionGroupBuf[ KeyMax ];	// [V O[v obt@p

	void Model3_DisplacePolyCnv( int id );	// fBXvCXg}bṽ|S



	//////////////////////////////////////////////////////////////////////////
	// ჌x֐
	   	 
	void BoneSceneCopy( int ps, int pe,  int bs, int be,  int ss, int se );


	MODEL3* Model3_MemorySecure();		// m
	
	void Model3_CopyA( MODEL3 *s, MODEL3 *e, bool mem_flag );		// s, e, m
	void Model3_DeleteA( MODEL3 *p );

	MATRIX LibModel3_BoneMatrixGet( int p, int b );
	void LibModel3_BoneMatrixSet( int p, int b, MATRIX mtx );

	MATRIX LibModel3_BoneMtxAngGet( int p, int b );

	XYZW LibModel3_BoneQtnGet( int p, int b );

	void Model3_TexSave( int _model, int _tex );	// 3D PaintŕҏWeNX`ۑp
}
