///////////////////////////////////////////////////////////////////////
// Obj2.h

#pragma once

namespace YJ_Lib
{
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// 2DIuWFNg( YJA` )

	struct OBJ2
	{
		struct IMG_DATA {
			char FileName[ BUF_MAX ];
			int  x, y;
		};

		struct KEY_NODE {

			int Frame;

			BOOL DrawFlag;

			XY	  Pos;
			float Ang;
			XY    Size;

			int ImgNo;

			int R, G, B, A;
		};


		struct KEY_MOTION_LIST {

			int KeySU;

			KEY_NODE *N;

			// ۑȂf[^
			int N_Mem;
		};


		struct MOTION {

			//OBJ_KEY_NODE K[ KeyMax ];

			BOOL	DrawFlagPoint;
			XY		PosPoint;
			float	AngPoint;
			XY		SizePoint;
			int		ImgNoPoint;
			int		R_Point;
			int		G_Point;
			int		B_Point;
			int		A_Point;

			KEY_MOTION_LIST *K;



			////////////////////////////////////////////////////////////
			// ۑȂf[^

			int   KeyNo;	// ߂L[t[
			float KeyF;		// L[t[̊Ԃ̏ꏊ


			// YJ Studio Editp
			BOOL OpenFlag;
			BOOL OpenDrawFlag;	// ۂɕ\H

		};

		int Ver;

		FileData file;

		
		int	 ImgSU;
		char ImgFile[ YJA_ImgMax ][ BUF_MAX ];
		int  ImgRotPX[ YJA_ImgMax ];	// ]
		int  ImgRotPY[ YJA_ImgMax ];

		int ObjSU;
		int Parent[ YJA_ObjMax ];
		int Child[ YJA_ObjMax ];
		int Sibling[ YJA_ObjMax ];
		int Dan[ YJA_ObjMax ];

		char Name[ YJA_ObjMax ][ BUF_MAX ];
		float ParentRot[ YJA_ObjMax ];	// ȇS]px


		/////////////////////////////////////////////////
		// [V

		MOTION M[ YJA_ObjMax ];	// [V

		int	LoopS, LoopE;


		// [Ṽ^Cv  0 JNJN  1 X[Y
		int AniTypePos;
		int AniTypeAng;
		int AniTypeSize;



		/////////////////////////////////////////////////
		// [VXg

		struct ML_DATA {

			ML_DATA(){
				sprintf( Name, "[V" );
				Frame		= 60;
				repeat		= true;
				next_motion	= -1;
			}

			char  Name[ BUF_MAX ];
			int   Frame;
			bool  repeat;		// s[gĐH
			short next_motion;	// [VĐAقȂ郂[VXgĐB
		};

		vector<ML_DATA> ML_Data;



		// ʉ
		int  WaveSU;
		char WaveFile[ WaveMax ][ 32 ];

		int  WaveNo[ KeyMax ];



		////////////////////////////////////////////////////////////////////////////////
		// ۑȂf[^

		int id;

		bool flag;			// ɃtO( false: true: )
//		bool load_flag;		// LoadItO
//		bool active_flag;	// Update()H
		bool draw_flag;		// `tO
//		bool delete_flag;	// tO

		int		f;
		float	f_add;		// t[Zp


		BOOL MotionAfterHide;

		int NowMotion;
		int ML_Now;			// ݂̃[VXgNo


		XY	  ModelPos;
		float ModelAng;
		XY	  ModelSize;




		/////////////////////////////////////////////////////////////////////////////////
		// ֐

		void Init();	// 
		void Update();	// XV

//		bool Load( char *file );	// t@Cǂݍ
		bool Save( char *file );	// t@Cۑ

		bool PosSet( XY xy );		// W
		bool PosSet( int x, int y );

//		BOOL Ang( Z );		// px
//		BOOL AngAdd( Z );	// ݂̊px{
//		BOOL Size( XY );	// TCY

		void Draw();
		BOOL DrawFlagSet(BOOL);
		BOOL FrameNoSet(int);
		void ImgRotP_Set(int,int);	// ]𒆉ɃZbg
		BOOL MotionAfterHideSet(BOOL);	// [VĐA\ɂB
	};

	int		Obj2_Create();		// 쐬
	OBJ2*	Obj2_Get(int);		// |C^擾
	int		Obj2_Num();			// IuWFNg擾


	


	void YJA_ImgLoad( int,int, char* );

	void YJA_Delete(int);
	void YJA_DeleteALL();

	void YJA_ImgDataGet(int,int);
	int  YJA_ImgDataGetRGB(int);
	int  YJA_ImgSizeX(int,int);
	int  YJA_ImgSizeY(int,int);

	XY	YJA_MaxImgSize(int);		// pĂeC[WŁAőX,Y߂
	void	YJA_KeyFrameCheck(int);

	void YJA_Animation();
	void YJA_SP( int, int,  int, float );

	void ObjKeyFrameCheck2(int);



//	bool Obj2_Copy( int s, int e );	// ff[^Rs[
//	void Obj2_Delete(int);			// f
//	void Obj2_DeleteALL();			// Sf

	OBJ2* Obj2_MemorySecure();		// m

//	int	Obj2_Load( char *file );	// t@Cǂݍ return:id
//	int	Obj2_Load( int id, char *file );	// t@Cǂݍ return:id
	int	Obj2_Load( char *folder, char *file );	// t@Cǂݍ return:id
}
